<?php 
#===================================================
# ТРЕБОВАНИЯ
// !!! для корректной работы скрипта необходима версия PHP 5.2.0 или выше !!!

#===================================================
# ДАННЫЕ ДЛЯ ПОДКЛЮЧЕНИЯ
$login = 'YOUR_LOGIN'; 							// логин
$key = 'YOUR_KEY'; 								// ключ доступа к API 
$url_json = 'http://positon.ru/api-json-v2/'; 	// Адрес API

#===================================================
# ДАННЫЕ ДЛЯ ПРОВЕРКИ

// Проверяемый сайт (1-й домен - основной /обязательно/, 2-й и далее - алиасы /необязательно/)
$Domains=array(
	'php.net',
	'wiki.php.net'
);

// Поисковые системы и регионы (для поиска и проверки доступных регионов используйте метод SearchRegion)
$Searchers=array(
	'Yandex.ru - Москва',
	'Google.ru - Москва'
);

// Поисковые фразы (дубликаты фраз и пустые элементы массива игнорируются)
$Phrases=array(
	'PHP documentation',
	'справочник PHP',
	'примеры PHP'
);

#===================================================
# ВЫПОЛНЕНИЕ

// Подключаем функции
include('get_positions_inc/functions.php');

// Получаем массив данных из файла
$data=data_load();

// соброс предыдущей проверки
if (isset($data['Status'])&&$data['Status']=='end'){
	if (isset($_GET['reset'])&&$_GET['reset']==1){
		$data=array();
		data_save($data);
	}
}

// запуск проверки
if (!isset($data['Status'])){
	if (!isset($_GET['start'])||$_GET['start']!=1){
		echo 'Данные для подключения к API и параметры проверки редактируются внутри скрипта.<br /><br /><a href="?start=1"><strong>Запустить проверку</strong></a>';
	} else {
		// тест подключение к API
		$res=api_request('PingAPI',array('Ping'=>1));
		if ($res['error']!=0){
			exit('Ошибка подключения к API. Код '.$res['error']);
		} else {
			$data=array('Status'=>'redy');
			data_save($data);
		}
	}
}

// отправляем данные для проверки
if (isset($data['Status'])&&$data['Status']=='redy'){

	// проверка баланса аккаунта
	$res=api_request('GetBalance',array(0));
	$units_account=$res['data']['Units'];
	$units_project=count($Searchers)*count($Phrases);
	if ($units_account<$units_project) exit('Для запуска проверки недостаточно средств. Требуется юнитов: '.$units_project);
	
	// создаем проект
	$params=array(
		'ProjectName'=>'',
		'ProjectCheckMode'=>0,
		'ProjectCheckDay'=>'',
		'ProjectCheckHour'=>0,
		'GroupName'=>'',
		'Domains'=>$Domains,
		'Searchers'=>$Searchers,
		'Phrases'=>$Phrases
	);
	$res=api_request('CreateProject',$params);
	if ($res['error']!=0) exit('Ошибка создания проекта. Код '.$res['error']);
	$prId=$res['data']['ProjectID'];
	
	// запускаем проверку
	$res=api_request('StartProject',array('ProjectIDs'=>array($prId)));
	if ($res['error']!=0) exit('Ошибка инициализации проверки. Код '.$res['error']);
	if ($res['data'][0]['Result']!='success') exit('Ошибка запуска проверки. '.$res['data'][0]['Description'].' Код '.$res['data'][0]['ErrorCode']);
	
	// сохраниям статус проверки и ID проекта в файл
	$data=array('Status'=>'wait','ProjectID'=>$prId);
	data_save($data);
}

// проверяем готовность
if (isset($data['Status'])&&$data['Status']=='wait'){
	$params=array(
		'ProjectID'=>$data['ProjectID'],
		'ShowProject'=>1,
		'ShowGroups'=>0,
		'ShowPhrases'=>0,
		'ShowLastCheck'=>0,
		'ShowPreviousCheck'=>0
	);
	$res=api_request('GetProjectParams',$params);
	if ($res['data']['CheckNow']==1){
		exit('Проект проверяется. Осталось времени: <strong>'.$res['data']['CheckTimer'].'</strong> (часы:минуты).<br /><br /><a href="?refresh=1"><strong>Перепроверить готовность</strong></a>');
	} else {
		$data['Status']='done';
		data_save($data);
	}
}

// получаем и сохраниям результат в файле
if (isset($data['Status'])&&$data['Status']=='done'){
	$params=array(
		'ProjectID'=>$data['ProjectID'],
		'ShowProject'=>1,
		'ShowGroups'=>1,
		'ShowPhrases'=>1,
		'ShowLastCheck'=>1,
		'ShowPreviousCheck'=>0
	);
	$res=api_request('GetProjectParams',$params);
	// сохраниям результат в файле
	$data['Result']=$res['data']['Groups'][0];
	$data['Status']='end';
	data_save($data);
	// удаляем временный проект
	$res=api_request('DeleteProject',array('ProjectID'=>$data['ProjectID']));
}

// выводим результат на страницу
if (isset($data['Status'])&&$data['Status']=='end'){
	$result=$data['Result'];
	
	// строим таблицу
	echo '<table border="1" cellspacing="0" cellpadding="2">';

	// шапка
	echo '<tr><th>Фраза</th><th>Статистика<br />Wordstat</th>';
	foreach ($result['Searchers'] as $ind=>$val){
		echo '<th>'.str_replace(' - ','<br />',$val).'</th>';
	}
	echo '</tr>';
	
	// выводим фразы и результаты
	foreach ($result['Phrases'] as $ind=>$val){
		echo '<tr><td>'.$val['Name'].'</td><td>'.$val['Wordstat'].'</td>';
		$positions=$val['PositionsLast']['BySearchers'];
		for($i=0; $i < count($positions); $i++){
			echo '<td>'.$positions[$i].'</td>';
		}
		echo '</tr>';
	}	
	echo '</table>';
	echo '<br /><a href="?reset=1"><strong>Сбросить результаты проверки</strong></a>';
}

?>